###################### hcopy.cl : IRAF  ###################
#
#.LANGAGES              IRAF CL
#.IDENTIFICATION        hcopy.cl
#.AUTHORS               Michael Murphy [IoA]
#.KEYWORDS              Utility
#.ENVIRONMENT
#.COMMENTS		
#.VERSION               1.0   2005 Aug 25
#
#+++++++++++++++++++++ Explanation for the function +++++++++++++++++++++++
#
#.PURPOSE Copy a nominated header card and value from one file to a
#         second file
#			
#			
#
#.RETURNS               No new files created. Only header keyword and value
#                       transfered.
#
#.ALGORITHM             Straightforward, uses IRAF cl language. Macro.
#
#.REMARKS               define by: task hcopy  = "scripts$hcopy.cl"
#$-------------------------------------------------------------------------

procedure hcopy (input1,input2)

    string	input1       {prompt='Image from which card and value read'}
    string	input2       {prompt='Image to which card and value written'}
    string	keywor1      {prompt='Header card name in first image'}
    string	keywor2      {prompt='Header card name in second image'}
    string	keytype      {"string",prompt='Keyword type: string, int, real'}

begin

# Declare parameters

	real    rheadval
	int     iheadval
	string	in1, in2, headkey1, headkey2, sheadval, headtyp

# Transfer to local variables
        in1=input1
	in2=input2
	headkey1=keywor1
	headkey2=keywor2
	headtyp=keytype

# If second keyword isn't specified then assume it's the same as the first
	if ((headkey2)==' ') {
	  headkey2=headkey1
	}

# Get the keyword from the header and copy it to the second file
	imgets (in1,headkey1)
	if ((headtyp)=='string') {
	  sheadval=imgets.value
	  hedit(in2,fields=headkey2,value=sheadval,add+,addonly-,delete-,verify-,
		show+,update+)
	}
	else if ((headtyp)=='int') {
	  iheadval=int(imgets.value)
	  hedit(in2,fields=headkey2,value=iheadval,add+,addonly-,delete-,verify-,
		show+,update+)
	}
	else if ((headtyp)=='real') {
	  rheadval=real(imgets.value)
	  hedit(in2,fields=headkey2,value=rheadval,add+,addonly-,delete-,verify-,
		show+,update+)
	}

# And that is all ...

end
