#!/usr/bin/perl -w

#use perl trace_create trace_name flat_name ref_slice number_of_slices
#            order_width spatial_binning
# eg   perl trace_create.pl tracename flatname 5 7 195 1

# number of slices is input
# traced slice index (1 to 7)
# number of traces is =2*slice numbers
# width of order is input, in pixels plus size of one inter-slice gap. For
#  example, for an order starting at pixel 159 and ending at pixel 353
#  with a gap of 4 pixels, the width is 353-159+1+4=201 pixels.
# center_i = C_tracedslice+[i-2*traced_slice_index-0.5)*(width_of_order/2*#slices))

$trace_name=shift(@ARGV);
$flat_name=shift(@ARGV);
$traced_slice=shift(@ARGV);
$number_slices=shift(@ARGV);
$width_order=shift(@ARGV); #im pixels
$spatial_binning=shift(@ARGV); #im pixels
$delta_x=($width_order/(2*$number_slices));
$apt_i=1; #initial value

while ($apt_i<=(2*$number_slices)){

  if ($apt_i<10){
    &write_trace_file("ap$trace_name","ap$flat_name\_0$apt_i",$traced_slice,$delta_x,$apt_i);
    system ("../trace_verify.csh ap$flat_name\_0$apt_i $spatial_binning");
  } else {
    &write_trace_file("ap$trace_name","ap$flat_name\_$apt_i",$traced_slice,$delta_x,$apt_i);
    system ("../trace_verify.csh ap$flat_name\_$apt_i $spatial_binning");
  }

    $apt_i=$apt_i+1;

}

sub write_trace_file{

my ($input) =shift (@_);
my ($output_trace) =shift (@_);
my ($ref_slice) =shift (@_);
my ($shift) =shift (@_);
my ($trace_numb) =shift (@_);

print "Now writing trace file for trace $trace_numb \n";
print "using reference slice $ref_slice \n"; 
print "with delta_x = $shift \n";
print "written to $output_trace\n";


@imagename=split(/ap/,$output_trace);
print "Image name is $imagename[1]\n";

$shift_to_center=$shift*($trace_numb-(2*$ref_slice-0.5));

print "shift to center (C + shift_to_center) = $shift_to_center \n";

system ("rm $output_trace");
open RESULT, ">>$output_trace";
select RESULT;

open (my $file,  "$input") || die "Could not open catalogue : $input !";
while  ($_=<$file>){
chomp $_;

#if((!(/center/))||(!/aperture trace/)||(!/low /)||(!/high /)){print "$_\n";}
if(/aperture $trace_name/o){
   # print "apt trace line is $_ \n";
my  @line = map {(split)[0..5]} $_;
    my $apt_num=$line[3];
    my $aptx=$line[4];
       $aptx=$aptx+$shift_to_center;
    my $apty=$line[5]; 
    print "begin   aperture $imagename[1] $apt_num $aptx $apty \n";
}
elsif(/image/o){
#    print "center line is $_ \n";
my  @line = map {(split)[0..1]} $_;
print "\timage\t$imagename[1]\n";
}#close if
elsif(/center/o){
#    print "center line is $_ \n";
my  @line = map {(split)[0..2]} $_;
my $centerx=$line[1]; 
   $centerx=$centerx+$shift_to_center;
my $centery=$line[2]; 
print "\tcenter\t$centerx $centery \n";
}#close if
elsif(/low\t/){
#    print "low line is $_ \n";
my  @line= map {(split)[0..2]} $_;
my $lowx=$line[1]; 
my $lowy=$line[2]; 
$lowx=-($shift/2);
print "\tlow\t$lowx $lowy \n";
}
elsif(/high\t/){
#    print "high line is $_ \n";
my  @line= map {(split)[0..2]} $_;
my $highx=$line[1];  
my $highy=$line[2]; 
$highx=($shift/2);
    print "\thigh\t$highx $highy \n";
}
elsif(/xmin/){
#    print "xmin line is $_ \n";
my  @line= map {(split)[0..1]} $_;
my $xmin=$line[1];
$xmin=-($shift/2);  
    print "\txmin $xmin\n";
}
elsif(/xmax/){
#    print "xmax line is $_ \n";
my  @line= map {(split)[0..1]} $_;
my $xmax=$line[1];  
$xmax=($shift/2);  
    print "\txmax $xmax\n";
}
else{print "$_\n";}
# also ch ange line with aperture trace, low, and high
} #close while



close RESULT;
close $file;
select STDOUT;#

} # close subroutine
